<?php
/*
Plugin Name: myGallery
Plugin URI: http://www.wildbits.de/mygallery/
Description: Yet another gallery.
Author: Thomas Boley
Version: 1.1b2

Author URI: http://www.wildbits.de


Copyright 2006  Thomas Boley  (email : tboley@web.de)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/ 

//#################################################################

define('myGalleryPath',dirname(__FILE__).'/');
define('myGalleryURL',get_bloginfo('wpurl').'/wp-content/plugins/mygallery/');

// read-write permissions for directorys and files

define('file_permissions',0666);
define('directory_permissions',0777);


@include_once(myGalleryPath. 'myfunctions/mygalleryfunctions.php');

if (!function_exists('getmygallerys')) {
	_e('Function library mygalleryfunctions.php was not found.', 'myGallery');
	die;
}

//#################################################################

//Fixes a bug in l10n.php where some guy decided there was no reason
// to load files which are required for their l10n functions if no language is defined in Wordpress.
// thanks to guys from WeatherIcon for the hint

require_once(ABSPATH . 'wp-includes/streams.php');
require_once(ABSPATH . 'wp-includes/gettext.php');

//#################################################################

function mygallery ($content) {
	
	global $table_prefix, $wpdb,$wp_rewrite, $myurl, $mg_options;
	
	$content= nasty_p_filter($content);
	
	// used variables 
	
	$mg_options = get_option('mygalleryoptions');
	$mg_exifoptions= get_option('mygexifoptions');
	$myurl=get_bloginfo('wpurl').'/'.$mg_options[gallerybasepath];
	$mypicture_id=$_GET[picture_id];
	$search = "/\[mygal=(\w+)\]/";
	$myreference=get_permalink();
	
	if ( $wp_rewrite->using_permalinks() ) {
		$mypicturenavigation=$myreference.'?picture_id=';
	}
	else {
		$mypicturenavigation=$myreference.'&amp;picture_id=';
	}
	
	
	
	if ($mypicture_id) {
		
		if (preg_match($search, $content)){
			
			$result=$wpdb->get_row('SELECT * FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$mypicture_id.' AND '.$table_prefix.'mygprelation.pid = '.$mypicture_id.' AND '.$table_prefix.'mygallery.id ='.$table_prefix.'mygprelation.gid' );
			
			// exit if there is no pictures with this id
			
			if (!$result) {
				return;	
			}
			
			$search = "/\[mygal=".$result->name."]/";
			$replace = "[mybigpic][mygal=".$result->name."]";
			$content = preg_replace ($search, $replace, $content);
			
			// get order option
			
			$mg_options=get_option('mygalleryoptions');
			if ($mg_options[sortorder]==1) $mysort='id';
			if ($mg_options[sortorder]==2) $mysort='picturepath';
			if ($mg_options[sortorder]==3) $mysort=' picsort';
			if ($mg_options[sortascdes]==2) $sortorder=' DESC';
			
			$my_foto_list=$wpdb->get_results('SELECT id FROM '.$table_prefix.'mypictures, '.$table_prefix.'mygprelation WHERE '.$table_prefix.'mygprelation.gid ='.$result->gid.' AND '.$table_prefix.'mypictures.id = '.$table_prefix.'mygprelation.pid ORDER BY '.$table_prefix.'mypictures.'.$mysort.$sortorder );
			
			// set pointer to the start of the array find position and build naviagtion
			
			reset ($my_foto_list);
			$mep=current($my_foto_list);
			$mep_id=$mep->id;
			
			while($mep_id != $mypicture_id){  
				$mep=next ($my_foto_list);
				$mep_id=$mep->id;
			}
			
			if (next ($my_foto_list)) {
				$mep=current($my_foto_list);
				$mep_id=$mep->id;
				$next='<a href="'.$mypicturenavigation.$mep_id.'" title="'.__('forward', 'myGallery').'">'.$mg_options[navigationfor].'</a>' ;
				prev ($my_foto_list);	
			}
			else {
				end ($my_foto_list);
			}
			
			if (prev ($my_foto_list)) {
				$mep=current($my_foto_list);
				$mep_id=$mep->id;
				$previous='<a href="'.$mypicturenavigation.$mep_id.'" title="'.__('back', 'myGallery').'">'.$mg_options[navigationback].'</a>';	
			}
			
			// show thumbs under bgc picture
			
			if ($mg_options[bigpicshowthumbs])  {
				$content=conv_tag($content); 
			}
			else {
				$search = "/\[mygal=(\w+)\]/";
				$replace='';
				$content = preg_replace ($search, $replace, $content);	
			}
			
			// get size of big picture
			
			$my_extension = strtolower(end(explode('.', ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$result->picturepath)));
			
			switch ($my_extension) {
				
				case "jpg": $mybigimg = imagecreatefromjpeg(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$result->picturepath);
				break;
				
				case "png": $mybigimg = imagecreatefrompng(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$result->picturepath);
				break;
				
				case "gif": $mybigimg = imagecreatefromgif(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$result->picturepath);
				break;
				
			}
			$mybigimg_width = imageSX($mybigimg);
			if ($mg_options[simplescale] AND ($mybigimg_width > $mg_options[simplescalewidth]))  {
				$mybigimg_width=$mg_options[simplescalewidth];
				$mybigimg_height = (int) (($mg_options[simplescalewidth] / imageSX($mybigimg)) * imageSY($mybigimg));
				if ($mg_options[lightboxjs]) $mylightboxref='rel="lightbox"';
				$fullref_pre='<a '.$mylightboxref.' href="'.$myurl.$result->name.'/'.$result->picturepath.'" title="'.$result->alttitle.'">';
				$fullref_post='</a>';
			}
			
			else {
				$mybigimg_height = imageSY($mybigimg);		
			}
			
			imagedestroy($mybigimg);
			
			// create HTML for big picture
			
			$search = "/\[mybigpic\]/";
			
			$replace='
			<div class="mypicbox">
			<div class="mypicup"><a href="'.$myreference.'" title="'.__('up', 'myGallery').'">'.$mg_options[navigationup].'</a></div>
			<div class="mypicture" style="width: '.$mybigimg_width.'px"><div class="mypictureborder" style="width: '.$mybigimg_width.'px">'.$fullref_pre.'<img class= "mypictureimg" src="'.$myurl.$result->name.'/'.$result->picturepath.'" alt="'.$result->alttitle.'" title="'.$result->alttitle.'" width="'.$mybigimg_width.'" height="'.$mybigimg_height.'" />'.$fullref_post.'</div></div>';
			
			if ($mg_options[galbpicdes]) {
				$replace=$replace.'<div class="myfooter"><span>'.$result->description.'</span></div>';
			}
			
			$replace=$replace.'<div class="mypicback">'.$previous.'</div>
			<div class="mypicfor">'.$next.'</div>
			</div>'; 
			
			if ($mg_exifoptions[showexif]) {
				$replace=$replace.getexifinfo(ABSPATH.$mg_options[gallerybasepath].$result->name.'/'.$result->picturepath);
			}
			$content = preg_replace ($search, $replace, $content);
			
		}	
	}
	
	else {
		
		// if there is no gallery_id match, function returns a empty page
		
		$content=conv_tag($content);
	}
	
	return $content;
}

//#################################################################

// gets the tumbnail gallery for a folder

function showtumbs($mygallery, $myrefmethod=0) {
	
	global $table_prefix, $wpdb, $wp_rewrite, $mg_options;
	
	// used variables 
	
	$myurl=get_bloginfo('wpurl').'/'.$mg_options[gallerybasepath].$mygallery.'/';
	
	$mydir=ABSPATH.$mg_options[gallerybasepath].$mygallery.'/tumbs/tmb_';
	
	$my_tumbs =array ();
	$myreference=get_permalink();
	
	if ( $wp_rewrite->using_permalinks() ) {
		$myreference=$myreference.'?picture_id=';
	}
	else {
		$myreference=$myreference.'&amp;picture_id=';
	}
	
	$mytumbs='<div class="mypicsgallery">';
	
	if ($myrefmethod) $mytumbs='<div class="mypicsgalleryentry">';
	
	// get order option
	
	$mg_options=get_option('mygalleryoptions');
	if ($mg_options[sortorder]==1) $mysort='id';
	if ($mg_options[sortorder]==2) $mysort='picturepath';
	if ($mg_options[sortorder]==3) $mysort=' picsort';
	if ($mg_options[sortascdes]==2) $sortorder=' DESC';
	
	$thepictures=$wpdb->get_results('SELECT * FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$table_prefix. 'mygprelation.pid AND '.$table_prefix.'mygprelation.gid = '.$table_prefix.'mygallery.id AND '.$table_prefix.'mygallery.name = "'.$mygallery.'" AND ('.$table_prefix.'mypictures.picexclude IS NULL OR '.$table_prefix.'mypictures.picexclude=0)  ORDER BY '.$table_prefix.'mypictures.'.$mysort.$sortorder );
	
	$mypage_id=$wpdb->get_var('SELECT pageid FROM '.$table_prefix.'mygallery WHERE name = "'.$mygallery.'"');
	
	
	if (is_array ($thepictures)){
		foreach ($thepictures as $tmp) {
			
			// get with and height of the thumbnails
			
			$my_extension = strtolower(end(explode('.', $mydir.$tmp->picturepath)));
			
			switch ($my_extension) {
				
				case "jpg": $myimg = imagecreatefromjpeg("$mydir$tmp->picturepath");
				break;
				
				case "png": $myimg = imagecreatefrompng("$mydir$tmp->picturepath");
				break;
				
				case "gif": $myimg = imagecreatefromgif("$mydir$tmp->picturepath");
				break;	
			}
			
			$myimg_width = imageSX($myimg);
			$myimg_height = imageSY($myimg);
			imagedestroy($myimg);
			
			//check for JavaScript reference method
			
			//if (!$myfirstpic AND $myrefmethod ) {
				
				// get size of big picture
				
				$my_extension = strtolower(end(explode('.', ABSPATH.$mg_options[gallerybasepath].$tmp->name.'/'.$tmp->picturepath)));
				
				switch ($my_extension) {
					
					case "jpg": $mybigimg = imagecreatefromjpeg(ABSPATH.$mg_options[gallerybasepath].$tmp->name.'/'.$tmp->picturepath);
					break;
					
					case "png": $mybigimg = imagecreatefrompng(ABSPATH.$mg_options[gallerybasepath].$tmp->name.'/'.$tmp->picturepath);
					break;
					
					case "gif": $mybigimg = imagecreatefromgif(ABSPATH.$mg_options[gallerybasepath].$tmp->name.'/'.$tmp->picturepath);
					break;
					
				}
				$mybigimg_width = imageSX($mybigimg);
				
				if ($mg_options[simplescale] AND ($mybigimg_width > $mg_options[simplescalewidth]))  {
					$mybigimg_width=$mg_options[simplescalewidth];
					$mybigimg_height = (int) (($mg_options[simplescalewidth] / imageSX($mybigimg)) * imageSY($mybigimg));
					if ($mg_options[lightboxjs]) $mylightboxref='rel="lightbox"';
					$fullref_pre='<a '.$mylightboxref.' href="'.$myurl.$tmp->picturepath.'" id="bmg'.$mygallery.'" alt="'.$result->alttitle.'">';
					$fullref_post='</a>';
				}
				
				else {
					$mybigimg_height = imageSY($mybigimg);		
				}
				
				imagedestroy($mybigimg);	
				
				if (!$myfirstpic AND $myrefmethod ) {	
					$myfirstpic='<div class="mypicboxentry"><div class="mypictureentry" style="width: '.$mybigimg_width.'px"><div class="mypictureentryborder" style="width: '.$mybigimg_width.'px">'.$fullref_pre.'<img class="mypictureentryimg" src="'.$myurl.$tmp->picturepath.'" id="mg'.$mygallery.'" alt="'.$tmp->alttitle.'" title="'.$tmp->alttitle.'" width="'.$mybigimg_width.'" height="'.$mybigimg_height.'" />'.$fullref_post.'</div></div>';	
					
					if  ($mg_options[igpicdes]) {
						$myfirstpic=$myfirstpic.'<div class="myfooter"><span  id="mg'.$mygallery.'ft">'.$tmp->description.'</span></div>';
						$myfirstpic=$myfirstpic.'<div style="display: none;" id="picid'.$tmp->pid.'">'.$tmp->description.'</div>';
					}
				}
				
				if ($myrefmethod) {
					$mypicture_ref="javascript:changePicture('".$myurl.$tmp->picturepath."','mg".$mygallery."','".$tmp->alttitle."',$mybigimg_width,$mybigimg_height,'picid".$tmp->pid."')";
					$myclass='class="mygallpicentry"';
				}
				
				else if ($mg_options[gallerybox]) {
					$mypicture_ref=$myurl.$tmp->picturepath;
					$mygalbox='rel="lightbox"';
				}
				
				else {
					$mypicture_ref=$myreference.$tmp->pid;
					$myclass='class="mygallpic"';
				}
				
				$mytumbs=$mytumbs.'<a '.$mygalbox.' href="'.$mypicture_ref.'"  title="'.$tmp->alttitle.'"><img '.$myclass.' width="'.$myimg_width.'" height="'.$myimg_height.'" src="'.$myurl.'tumbs/tmb_'.$tmp->picturepath.'" alt="'.$tmp->alttitle.'" title="'.$tmp->alttitle.'" /></a>';
				if  ($mg_options[igpicdes]) {
					$mytumbs=$mytumbs.'<span style="display: none;" id="picid'.$tmp->pid.'">'.$tmp->description.'</span>';
				}
		}
	}
	if ($myrefmethod) $endtag='</div>';
	
	$mytumbs=$mytumbs.'</div>';
	$mytumbs=$myfirstpic.$mytumbs.$endtag;
	
	return $mytumbs;
}

//#################################################################

// reads all mygallery-tags an replaces the tags with content

function conv_tag($mystring) {
	
	// used variables 
	
	$search = "/\[mygal=(\w+)\]/";
	$mg_options=get_option('mygalleryoptions');
	
	global $myurl; 
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		if (is_array ($temp_array[1])) {
			foreach ($temp_array[1] as $v0) {
				$search = "/\[mygal=".$v0."\]/";
				$replace= showtumbs($v0);
				$mystring= preg_replace ($search, $replace, $mystring);
			}
			
		}
	}
	$search = "/\[mygallistgal\]/";
	
	if (preg_match($search, $mystring)){
		
		if (preg_match($search, $mystring)){
			$replace='<div class="mygalleryoverview">';
			
			// get gallerys 
			
			if (!$_GET[galpage] AND $mg_options[galpagebreak]) {
				$mygalpage=1;
			} 
			else if ($mg_options[galpagebreak])
			{
				$mygalpage=$_GET[galpage];
			}
			
			list ($gallerys,$gallerynavigation)=spreedgallerytopages($mygalpage);
			
			if (is_array($gallerys)) {
				foreach ($gallerys as $x) {
					$longname='';
					if ($mg_options[longnames]) $longname=getgallerylongname($x->id);
					if (!$longname) $longname=$x->name;
					
					$replace=$replace. '<div class="mygallerygallery"><div class="mygallerynames"><a href="'.get_permalink($x->pageid).'">'.$longname.'</a></div><div class="mygallpicdesbord ">';
					
					if ($mg_options[previewpic] AND ($x->previewpic)) {
						$mypicturepath=getpicturepath($x->previewpic);
						$myalttitle=getalttitle($x->previewpic);
						$replace=$replace.'<div class="mygallerypreviewpics"><a href="'.get_permalink($x->pageid).'"><img src="'.$myurl.$x->name.'/tumbs/tmb_'.$mypicturepath.'" alt="'.$myalttitle.'" title="'.$myalttitle.'"/></a></div>'; // Bezug zum Bild fehlt
					}
					if ($mg_options[galdescrip]) {
						$mydescription=getgallerydescrip($x->id);
						$replace=$replace.'<div class="mygallerydescription">'.$mydescription.'</div>';
					}
					$replace=$replace.'</div></div>';		
				}
			}
			$replace=$replace.'</div>'.$gallerynavigation;
			$search = "/\[mygallistgal\]/";
			$mystring= preg_replace ($search, $replace, $mystring);
		}
		
	}
	
	$search = "/\[myginpage=(\w+)\]/";
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		
		if (is_array($temp_array[1])) {
			foreach ($temp_array[1] as $v0) {
				$search = "/\[myginpage=".$v0."\]/";
				$replace=showtumbs($v0,1);
				$mystring= preg_replace ($search, $replace, $mystring);
			}
			
		}
	}
	
	
	$search = "/\[inspic=(\d+)(|,\w+|,)(|,fullscreen|,gal|,)(|,thumb|,\d+)\]/";
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		
		if (is_array($temp_array)) {
			foreach ($temp_array[1] as $key =>$v0) {
				$search = "/\[inspic=".$v0.$temp_array[2][$key].$temp_array[3][$key].$temp_array[4][$key]."\]/";
				$replace=myinlinepicture($v0,$temp_array[2][$key],$temp_array[3][$key],$temp_array[4][$key]);
				$mystring= preg_replace ($search, $replace, $mystring);
			}	
		}
	}
	
	$search = "/\[mypicref=(\d+)\](.*)\[\/mypicref\]/U";	
	
	if (preg_match($search, $mystring)){
		
		preg_match_all($search, $mystring, $temp_array);
		
		if (is_array($temp_array[1])) {
			foreach ($temp_array[1] as $key => $v0) {
				$search = "/\[mypicref=".$v0."\](.*)\[\/mypicref\]/U";	
				$replace=mytextpiclink($v0,$temp_array[2][$key]);
				$mystring= preg_replace ($search, $replace, $mystring);
			}	
		}
	}
	
	$mystring=" \t".$mystring;
	return $mystring;
}
//#################################################################

// adminpanel functions

function mygallery_menu() {
	if (function_exists('add_menu_page')) {
		
		add_menu_page('mygallery Generator', 'myGallery',6,dirname(__FILE__).'/myfunctions/mygallerymain.php');	
		
	}
	
	if (function_exists('add_submenu_page')) {
		$mg_options=get_option('mygalleryoptions');
		
		if ($mg_options[language]) load_textdomain('myGallery', myGalleryPath.'/languages/'.$mg_options[language].'.mo');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Gallery Management', 'myGallery'), __('Gallery Management', 'myGallery'), 6,dirname(__FILE__).'/myfunctions/mygalleryadmin.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Options', 'myGallery'), __('Options', 'myGallery'), 6,dirname(__FILE__).'/myfunctions/mygalleryoptions.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Gallery Style', 'myGallery'),__('Gallery Style', 'myGallery'), 10,dirname(__FILE__).'/myfunctions/mygallerystyle.php');
		add_submenu_page( dirname(__FILE__).'/myfunctions/mygallerymain.php', __('Exif Settings', 'myGallery'), __('Exif Settings', 'myGallery'), 6,dirname(__FILE__).'/myfunctions/mygalleryexif.php');
		
	}
}

//#################################################################

function myrandompic($myamount=1) {
	
	global $table_prefix, $wpdb,$wp_rewrite,$mg_options;
	
	// used variables 
	
	$mybaseurl=get_bloginfo('wpurl');
	$mg_options=get_option('mygalleryoptions');
	$myurl=$mybaseurl.'/'.$mg_options[gallerybasepath];
	
	// read pictures table into array
	
	$mg_options=get_option('mygalleryoptions');
	
	
	if ($mg_options[excludeoverview]) {
		$mypicturesarray = $wpdb->get_results('SELECT '.$table_prefix.'mypictures.id FROM '.$table_prefix.'mypictures, '.$table_prefix.'mygallery, '.$table_prefix.'mygprelation WHERE ' .$table_prefix.'mypictures.id = '.$table_prefix. 'mygprelation.pid AND '.$table_prefix.'mygprelation.gid = '.$table_prefix.'mygallery.id AND ('.$table_prefix.'mygallery.excludegal IS NULL OR '.$table_prefix.'mygallery.excludegal=0 ) AND ('.$table_prefix.'mypictures.picexclude IS NULL OR '.$table_prefix.'mypictures.picexclude=0)');
		
	}
	
	else {
		
		$mypicturesarray = $wpdb->get_results('SELECT id FROM '.$table_prefix.'mypictures WHERE '.$table_prefix.'mypictures.picexclude IS NULL OR '.$table_prefix.'mypictures.picexclude=0');
	}
	
	// exit if no gallery pictures are found
	
	if (!$mypicturesarray) {
		return;	
	}
	// get random element(s)
	
	for ($i =1; $i<=$myamount; $i++){
		srand();
		$myrandomid=$mypicturesarray[ array_rand ($mypicturesarray)]->id;
		
		// read element infos
		
		$result=$wpdb->get_row('SELECT * FROM '.$table_prefix.'mypictures,'.$table_prefix.'mygprelation,'.$table_prefix.'mygallery WHERE '.$table_prefix.'mypictures.id = '.$myrandomid.' AND '.$table_prefix.'mygprelation.pid = '.$myrandomid.' AND '.$table_prefix.'mygallery.id ='.$table_prefix.'mygprelation.gid' );
		
		$mypage_id=$wpdb->get_var('SELECT pageid FROM '.$table_prefix.'mygallery WHERE id ='.$result->gid);
		
		
		// return picture
		
		if ($mypage_id) {
			
			$myreference=get_permalink($mypage_id);
			
			if ( $wp_rewrite->using_permalinks() ) {
				$myreference=$myreference.'?picture_id=';
			}
			else {
				$myreference=$myreference.'&amp;picture_id=';
			}
			
			
			$myhyperlink_open='<a href="'.$myreference.$result->pid.'">';
			$myhyperlink_close='</a>';
		}
		
		$mypicstring=$mypicstring.'<div class="myrandompic">'.$myhyperlink_open.'<img src="'.$myurl.$result->name.'/tumbs/tmb_'.$result->picturepath.'" alt="'.$result->alttitle.'" title="'.$result->alttitle.'" />'.$myhyperlink_close.'</div>';
	}
	
	
	echo $mypicstring;// maybe not the best way to show the result
	
}

//#################################################################

function myGalleryJScript() {
	
	global $mg_options;
	
	$myscript = '<script type="text/javascript">'."
	function changePicture(img, galid,myalt,mywidth,myheight,myftid) {
		document.getElementById(galid).setAttribute('src',img);
		document.getElementById(galid).setAttribute('alt',myalt);
		document.getElementById(galid).setAttribute('title',myalt);";
		if ($mg_options[igsafewh]) {
			$myscript =$myscript."document.getElementById(galid).setAttribute('width',mywidth);
			document.getElementById(galid).setAttribute('height',myheight);";
		}
		$myscript =$myscript."bigid='b'+galid;
		document.getElementById(bigid).setAttribute('href',img);
		var footerid=galid+'ft';
		document.getElementById(footerid).firstChild.nodeValue=document.getElementById(myftid).firstChild.nodeValue;
	}
	</script>";
	echo $myscript;
	
}

//#################################################################

function myGalleryStyle() {
	
	global $mg_options;
	
	$mystyle="\n".'<style type="text/css" media="screen">'."\n".'@import url('.get_bloginfo('wpurl').'/wp-content/plugins/mygallery/css/'.$mg_options[stylefile].');'."\n".'</style>';
	echo $mystyle;
}
//#################################################################

function includeLightboxJS() {
	$myscript = '<script type="text/javascript">'.'
	var loadingImage = \''.get_bloginfo('wpurl').'/wp-content/plugins/mygallery/lightbox-plugin/loading.gif\';'."\n".'var closeButton = \''.get_bloginfo('wpurl').'/wp-content/plugins/mygallery/lightbox-plugin/close.png\';
	</script>'."\n".'<script type="text/javascript" src="'.get_bloginfo('wpurl').'/wp-content/plugins/mygallery/lightbox-plugin/lightbox.js"></script>';
	$myscript=$myscript."\n".'<style type="text/css" media="screen">'."\n".'@import url('.get_bloginfo('wpurl').'/wp-content/plugins/mygallery/lightbox-plugin/lightbox.css);'."\n".'</style>';
	echo $myscript;
}
//#################################################################
function my_button_init() {
	
	// used to insert button in wordpress 2.x editor
	
	$button_image_url = buttonsnap_dirname(__FILE__) . '/images/mgbrowser.gif';
	
	buttonsnap_jsbutton($button_image_url, 'myGallery Browser', 'window.open("'.myGalleryURL.'myfunctions/mygallerybrowser.php?myPath='.ABSPATH.'", "myGalleryBrowser",  "width=700,height=600,scrollbars=yes");');
}

//#################################################################

// init mygallery tables in wp-database if plugin is activated

if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
	
	require_once(ABSPATH . 'wp-content/plugins/mygallery/myfunctions/mygalleryinstall.php');
	add_action('init', 'mygallery_install');
}

// adding functions to wordpress

add_filter('the_content', 'mygallery',9); 

add_action('admin_menu', 'mygallery_menu');

// add JavaScript to header

add_action('wp_head', 'myGalleryJScript');

// add Stlye to header

$mg_options=get_option('mygalleryoptions');

if ($mg_options[includestyle]) add_action('wp_head', 'myGalleryStyle');

// add Lightbox JS to header

if ($mg_options[lightboxjs]) add_action('wp_head', 'includeLightboxJS');

// add gallerybrowser for posts

$myswitch=reset(explode('.', get_bloginfo('version')));

switch ($myswitch) {
	
	case 1:	
	@include_once(myGalleryPath. 'myfunctions/mygallery_button.php');
	add_filter('admin_footer', 'mygallery_picturebrowser');
	break;
	
	case 2:
	@include_once(myGalleryPath.'myfunctions/buttonsnap.php');	
	add_action('init', 'my_button_init');
	break;
}

?>